unit obliquelaborde_courbure;

// cas de la projection Gauss-Laborde Oblique dfinie avec une sphre de courbure

// documentation : voir Laborde Oblique

interface

uses
  projection, obliquelaborde_reel, laborde;

type

  TLabordeOblic_courbure = class(TLabordeOblic_reel)
  private
  protected
    function GetNature : string; override;
    procedure ConvertirParam; override; // convertit les paramtres vers la projection TLabordeOblic (gnrique)
  public
  end;

implementation

uses
  ign, outils;

function TLabordeOblic_courbure.GetNature : string;
begin
   result:=tpGaussLabordeObliqueCourbure;
end;


procedure TLabordeOblic_courbure.ConvertirParam;
// convertit les paramtres vers la projection TLabordeOblic (gnrique)
var
  n1, c, n2, Ys, Phi0 : real;
begin
  try
    Phi0:=StrToAngle(ParamAngle[1]);
    alg0046_courbure(Datum.Ellipsoide.a, Datum.Ellipsoide.e, Phi0, ParamReal[0],
                     ParamReal[2],
                     n1, c, n2, Ys);
    Phi0:=n1*alg0001(Phi0,Datum.Ellipsoide.e)+c; // latitude sur la sphre du centre de la projection
    Remonte(n1, n2, c, ParamReal[1], {Ys}ParamReal[2], ParamAngle[0], AngleToStr(Phi0,uaGrade),
            ParamAngle[2]);
  except
  end;
end;

end.
